// Canne_a_son_Teensy4             YLC 18/06/2021
// Sonorisation de la détection d'obstacles par mesure des variations brutales de distance
// Jusqu'à 1,10 m le seuil de variation est de 5 cm au-delà de cette distance le seuil est de 15 cm. 
// Harware : Teensy 4.1 + lidar TF mini PLus + Buzzer + alim 5v.
// A savoir : Tests sur Arduino nano => ne fonctionnent pas correctement car carte trop lente. 
//******************************************************************
#define PorSerLid Serial2       // déclaration du lidar TF mini sur port série #2 (pins 7 et 8)
#include "TFMiniPlus.h"
TFMiniPlus tfmini;

#include "EasyBuzzer.h"  

float dis = 0;                 // distance mesurée par Lidar
float dist = 0;                // distance retenue
int vardis = 0;                // écart de distance entre 2 mesures
unsigned int freqson;          // fréquence du bip sonore
const int dischangseuil = 110; // distance de changement de seuil de détection
const int seuilproch = 5;      // seuil de détection pour les obstacles proches
const int seuileloin = 15;     // seuil de détection pour les obstacles éloignés
int vardimi;                   // seuil chosi pour activer signal sonore (cm)
float dislid[2];               // tableau de stockage des mesures faite par le lidar 
bool premes = true;            // indicateur de la première mesure

//__________________________________________________________________

void mesure()  {
  if (tfmini.readData()) {         // Récupération de la mesure lidar  
    dis = tfmini.getDistance();    // distance mesurée 
    if (dis > 500)   dis = 500;    // on ne va pas a plus de 5 m
    if (dis > 15) {                // si mesure valide de plus de 15 cm
      dist = dis;                  // distance est retenue
    }
  }
}
//=========================================================

void setup() {
  EasyBuzzer.update();          // correction bug dans lib EasyBuzzer
  EasyBuzzer.setPin(14);        // pin 14 : Pin buzzer 
  PorSerLid.begin(115200);      // ouverture du port série 2 (Lidar)
  tfmini.begin(&PorSerLid);     // démarrer le lidar sur port série #2
  tfmini.setFrameRate(50);      // fixer la fréquence du Lidar (Hz)
  tfmini.saveSettings();        // enegistrer les réglages 
}
//=========================================================

void loop() { 
  mesure();                      // récupérer une distance
  if (dist > 0)  {               // si distance mesurée
    dislid[0] = dislid[1];       // décaler la mesure précédente dans premier poste
    dislid[1] = dist;            // stocker nouvelle mesure dans second poste
    if (premes) {                // si premiere mesure on ne fait rien d'autre
      premes = false;            // pour indiquer les mesures suivantes    
    }
    else {
      vardis = abs(dislid[0] - dislid[1]);  // calcul de l'écart entre 2 mesures 
      if (dislid[1] < dischangseuil) {      // si mesure "proche"
        vardimi = seuilproch;               // seuil proche activé
      }
      else vardimi = seuileloin;            // seuil éloigné activé
      if (vardis > vardimi) {               // Si écart de distance supérieur au seuil retenu
        freqson = 2500 - (dislid[1] * 4);   // calcul fréquence fonction(dernière distance mesurée)
        EasyBuzzer.singleBeep(freqson,50);  // jouer le son calculé 50 millisec.
        delay(50);                          // attendre la fin du son
        EasyBuzzer.stopBeep();              // arrêter le buzzer
      }       
    } 
  }                  
}   
//**********************fin prog******************************/
